## mingw-w64-vtk-9.5.0-4.src.tar.zst

=== IO/ParallelLSDyna/CMakeLists.txt ===
set(classes
  vtkPLSDynaReader)

vtk_module_add_module(VTK::IOParallelLSDyna
  CLASSES ${classes})
vtk_add_test_mangling(VTK::IOParallelLSDyna)
