=== IO/AMR/Testing/CMakeLists.txt ===
vtk_module_test_data(
  Data/AMR/Enzo/DD0010/,REGEX:.*
  Data/AMR/Flash/,REGEX:.*
  Data/AMR/Velodyne/,REGEX:.*)

add_subdirectory(Cxx)
